"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const anchor = __importStar(require("@wum.bo/anchor"));
const web3_js_1 = require("@solana/web3.js");
const spl_utils_1 = require("@wum.bo/spl-utils");
const spl_token_bonding_1 = require("@wum.bo/spl-token-bonding");
const spl_token_collective_1 = require("@wum.bo/spl-token-collective");
const common_1 = require("@project-serum/common");
const spl_token_1 = require("@solana/spl-token");
const fs_1 = __importDefault(require("fs"));
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(process.env.ANCHOR_PROVIDER_URL);
        anchor.setProvider(anchor.Provider.env());
        const provider = anchor.getProvider();
        const splTokenBondingProgramId = new web3_js_1.PublicKey("TBondz6ZwSM5fs4v2GpnVBMuwoncPkFLFR9S422ghhN");
        const splTokenCollectiveProgramId = new web3_js_1.PublicKey("WumbodN8t7wcDPCY2nGszs4x6HRtL5mJcTR519Qr6m7");
        const splTokenBonding = new anchor.Program(spl_token_bonding_1.SplTokenBondingIDLJson, splTokenBondingProgramId, provider);
        const splTokenCollective = new anchor.Program(spl_token_collective_1.SplTokenCollectiveIDLJson, splTokenCollectiveProgramId, provider);
        const splTokenBondingProgram = new spl_token_bonding_1.SplTokenBonding(provider, splTokenBonding);
        const splTokenCollectiveProgram = new spl_token_collective_1.SplTokenCollective({
            provider,
            program: splTokenCollective,
            splTokenBondingProgram,
        });
        const wallet = splTokenCollectiveProgram.wallet.publicKey;
        yield splTokenBondingProgram.initializeSolStorage();
        const curve = yield splTokenBondingProgram.initializeCurve({
            config: new spl_token_bonding_1.ExponentialCurveConfig({
                c: 0.001,
                b: 0,
                pow: 1,
                frac: 2
            })
        });
        const socialCurve = yield splTokenBondingProgram.initializeCurve({
            config: new spl_token_bonding_1.ExponentialCurveConfig({
                c: 0.0001,
                b: 0,
                pow: 1,
                frac: 2
            })
        });
        const signers1 = [];
        const instructions1 = [];
        const openMintKeypair = web3_js_1.Keypair.fromSecretKey(new Uint8Array(JSON.parse(fs_1.default.readFileSync(process.env.OPEN_MINT_PATH).toString())));
        signers1.push(openMintKeypair);
        const openMint = openMintKeypair.publicKey;
        instructions1.push(...(yield common_1.createMintInstructions(provider, wallet, openMint, 9)));
        yield spl_utils_1.createMetadata(new spl_utils_1.Data({
            symbol: "OPEN",
            name: "Open Collective",
            uri: "https://wumbo-token-metadata.s3.us-east-2.amazonaws.com/open.json",
            sellerFeeBasisPoints: 0,
            // @ts-ignore
            creators: null,
        }), wallet.toBase58(), openMint.toBase58(), wallet.toBase58(), instructions1, wallet.toBase58());
        const { instructions: openCollectiveInstructions, signers: openCollectiveSigners, output: { collective: openCollective } } = yield splTokenCollectiveProgram.createCollectiveInstructions({
            mintAuthority: wallet,
            authority: wallet,
            mint: openMint,
            config: {
                isOpen: true,
                unclaimedTokenBondingSettings: {
                    curve: socialCurve,
                    buyBaseRoyalties: {
                        ownedByName: true,
                    },
                    sellBaseRoyalties: {
                        ownedByName: true,
                    },
                    buyTargetRoyalties: {
                        ownedByName: true,
                    },
                    sellTargetRoyalties: {
                        ownedByName: true,
                    },
                    minBuyBaseRoyaltyPercentage: 0,
                    maxBuyBaseRoyaltyPercentage: 0,
                    minSellBaseRoyaltyPercentage: 0,
                    maxSellBaseRoyaltyPercentage: 0,
                    minBuyTargetRoyaltyPercentage: 5,
                    maxBuyTargetRoyaltyPercentage: 5,
                    minSellTargetRoyaltyPercentage: 0,
                    maxSellTargetRoyaltyPercentage: 0,
                },
                unclaimedTokenMetadataSettings: {
                    symbol: "UNCLAIMED",
                    nameIsNameServiceName: true
                },
                claimedTokenBondingSettings: {
                    maxSellBaseRoyaltyPercentage: 20,
                    maxSellTargetRoyaltyPercentage: 20,
                }
            }
        });
        // Change authority back to token bonding
        const instructions3 = [];
        const [openMintAuthority] = yield web3_js_1.PublicKey.findProgramAddress([Buffer.from("target-authority", "utf-8"), openMint.toBuffer()], splTokenBondingProgramId);
        instructions3.push(spl_token_1.Token.createSetAuthorityInstruction(spl_utils_1.TOKEN_PROGRAM_ID, openMint, openMintAuthority, "MintTokens", wallet, []));
        const { instructions: bondingInstructions, signers: bondingSigners, output: { targetMint, tokenBonding } } = yield splTokenBondingProgram.createTokenBondingInstructions({
            curve,
            baseMint: new web3_js_1.PublicKey("So11111111111111111111111111111111111111112"),
            targetMintDecimals: 9,
            authority: wallet,
            targetMint: openMint,
            buyBaseRoyaltyPercentage: 0,
            buyTargetRoyaltyPercentage: 0,
            sellBaseRoyaltyPercentage: 0,
            sellTargetRoyaltyPercentage: 0,
            index: 0
        });
        instructions3.push(...bondingInstructions);
        const connection = provider.connection;
        console.log("Sending txn 1/3...");
        const tx1 = new web3_js_1.Transaction({
            recentBlockhash: (yield connection.getRecentBlockhash('finalized')).blockhash,
            feePayer: wallet
        });
        tx1.add(...instructions1);
        yield splTokenCollectiveProgram.provider.send(tx1, signers1, { commitment: 'finalized', preflightCommitment: 'finalized' });
        console.log("Sending txn 2/3...");
        const tx2 = new web3_js_1.Transaction({
            recentBlockhash: (yield connection.getRecentBlockhash('finalized')).blockhash,
            feePayer: wallet
        });
        tx2.add(...openCollectiveInstructions);
        yield splTokenCollectiveProgram.provider.send(tx2, openCollectiveSigners, { commitment: 'finalized', preflightCommitment: 'finalized' });
        console.log("Sending txn 3/3...");
        const tx3 = new web3_js_1.Transaction({
            recentBlockhash: (yield connection.getRecentBlockhash('finalized')).blockhash,
            feePayer: wallet
        });
        tx3.add(...instructions3);
        yield splTokenCollectiveProgram.provider.send(tx3, bondingSigners, { commitment: 'finalized', preflightCommitment: 'finalized' });
        yield splTokenCollectiveProgram.account.collectiveV0.fetch(openCollective);
        console.log(`Open Collective: ${openCollective}, bonding: ${tokenBonding}, open: ${targetMint}, openMetadata: ${yield spl_utils_1.getMetadata(openMint.toBase58())}`);
    });
}
run().catch(e => {
    console.error(e);
    process.exit(1);
});
//# sourceMappingURL=bootstrap.js.map